Files
@ aa51aca7fd1a
Branch filter:
Location: kallithea/scripts/validate-minimum-dependency-versions - annotation
aa51aca7fd1a
1.6 KiB
text/plain
controller: Handle UnicodeDecodeError from webob decoding invalid URLs
webob will try to utf-8 decode all %-encoded bytes in URL-parameters, but will
not handle Unicode erors ... and neither did Kallithea. Visiting a URL like
http://localhost:5000/?%AD would thus give an unhandled exception showing
"Internal Server Error" to the user, and logging the full traceback and:
WebApp Error: UnicodeDecodeError: 'utf-8' codec can't decode byte 0xad in position 0: invalid start byte
This has been seen a lot recently from attackers probing for a php
vulnerability
https://devco.re/blog/2024/06/06/security-alert-cve-2024-4577-php-cgi-argument-injection-vulnerability-en/ .
Now handle these exceptions more nicely and reject with "400 Bad Request".
webob will try to utf-8 decode all %-encoded bytes in URL-parameters, but will
not handle Unicode erors ... and neither did Kallithea. Visiting a URL like
http://localhost:5000/?%AD would thus give an unhandled exception showing
"Internal Server Error" to the user, and logging the full traceback and:
WebApp Error: UnicodeDecodeError: 'utf-8' codec can't decode byte 0xad in position 0: invalid start byte
This has been seen a lot recently from attackers probing for a php
vulnerability
https://devco.re/blog/2024/06/06/security-alert-cve-2024-4577-php-cgi-argument-injection-vulnerability-en/ .
Now handle these exceptions more nicely and reject with "400 Bad Request".
ac6cc1b8a07e ac6cc1b8a07e ac6cc1b8a07e ac6cc1b8a07e ac6cc1b8a07e ac6cc1b8a07e ac6cc1b8a07e ac6cc1b8a07e ac6cc1b8a07e ac6cc1b8a07e ac6cc1b8a07e ac6cc1b8a07e ac6cc1b8a07e ac6cc1b8a07e ac6cc1b8a07e ac6cc1b8a07e ac6cc1b8a07e ac6cc1b8a07e ac6cc1b8a07e ac6cc1b8a07e ac6cc1b8a07e ac6cc1b8a07e ac6cc1b8a07e ac6cc1b8a07e ac6cc1b8a07e ac6cc1b8a07e ac6cc1b8a07e ac6cc1b8a07e ac6cc1b8a07e ac6cc1b8a07e 89e9aef9b983 ac6cc1b8a07e ff6c3e285166 ac6cc1b8a07e ac6cc1b8a07e ac6cc1b8a07e ac6cc1b8a07e ac6cc1b8a07e ac6cc1b8a07e ac6cc1b8a07e ac6cc1b8a07e ac6cc1b8a07e ac6cc1b8a07e ac6cc1b8a07e ac6cc1b8a07e ac6cc1b8a07e ac6cc1b8a07e ac6cc1b8a07e ac6cc1b8a07e ac6cc1b8a07e ac6cc1b8a07e ac6cc1b8a07e | #!/bin/bash
# Test that installation of all dependencies works fine if versions are set to
# the minimum ones.
set -e
if [ -n "$VIRTUAL_ENV" ]; then
echo "This script will create its own virtualenv - please don't run it inside an existing one." >&2
exit 1
fi
cd "$(hg root)"
venv=build/minimum-dependency-versions-venv
log=build/minimum-dependency-versions.log
min_requirements=build/minimum-dependency-versions-requirements.txt
echo "virtualenv: $venv"
echo "log: $log"
echo "minimum requirements file: $min_requirements"
# clean up previous runs
rm -rf "$venv" "$log"
mkdir -p "$venv"
# Make a light weight parsing of setup.py and dev_requirements.txt,
# finding all >= requirements and dumping into a custom requirements.txt
# while fixating the requirement at the lower bound.
sed -n 's/.*"\(.*\)>=\(.*\)".*/\1==\2/p' setup.py > "$min_requirements"
sed 's/>=/==/p' dev_requirements.txt >> "$min_requirements"
python3 -m venv "$venv"
source "$venv/bin/activate"
pip install --upgrade "pip<24.1" "setuptools<67"
pip install -e . -r "$min_requirements" python-ldap python-pam 2> >(tee "$log" >&2)
# Treat any message on stderr as a problem, for the caller to interpret.
if [ -s "$log" ]; then
echo
echo "Error: pip detected following problems:"
cat "$log"
echo
exit 1
fi
freeze_txt=build/minimum-dependency-versions.txt
pip freeze > $freeze_txt
echo "Installation of minimum packages was successful, providing a set of packages as in $freeze_txt . Now running test suite..."
pytest
echo "Test suite execution was successful."
echo "You can now do additional validation using virtual env '$venv'."
|